﻿using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Data;

namespace HierarchyColumnsBackground
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow
	{
		public MainWindow()
		{
			InitializeComponent();

			GridViewTableDefinition detailDefinition = new GridViewTableDefinition();
			detailDefinition.Relation = new PropertyRelation("Orders");
			this.radGridViewHierarchyColumnsBackground.TableDefinition.ChildTableDefinitions.Add(detailDefinition);

			this.DataContext = BuildCustomers();
		}

		private static ObservableCollection<Customer> BuildCustomers()
		{
			ObservableCollection<Customer> customers = new ObservableCollection<Customer>();

			ObservableCollection<Order> orders = new ObservableCollection<Order>();

			for (int i = 0; i < 10; i++)
			{
				orders.Add(new Order { Number = i, Details = "Order" + i });
			}

			for (int i = 0; i < 100; i++)
			{
				customers.Add(new Customer { Email = "Mail" + i, Name = "Name" + i, Number = i, Orders = orders });
			}

			return customers;
		}

		private void ChildGridViewControl_Loaded(object sender, RoutedEventArgs e)
		{
			GridViewDataControl dataControl = (GridViewDataControl) e.OriginalSource;

			Brush verticalLinesBrush = (Brush) this.radGridViewHierarchyColumnsBackground.Resources["verticalLinesBrush"];

			foreach (GridViewColumn column in dataControl.Columns)
			{
				column.Background = Brushes.Yellow;
				column.VerticalGridlinesBrush = verticalLinesBrush;
			}
		}
	}
}
